package jas;
import robocode.*;
import java.awt.Color;


/**
 * FrostBight - a robot by 9921
 */
public class Iceberg extends AdvancedRobot {
	/**
	 * run: FrostBight's default behavior
	 */
	
	public void run() {
		
		setColors(Color.blue, Color.black, Color.blue);
		
		int others = getOthers();
		
		while(true) {
			// Replace the next 4 lines with any behavior you would like
			ahead(1000);
			turnGunRight(1);
			opportunist(getOthers());
			back(500);
			turnGunRight(360);
			turnLeft(90);
			turnGunLeft(1);
			ahead(550);
		}//end while
	}// end run

	/**
	 * onScannedRobot: What to do when you see another robot
	 */
	public void onScannedRobot(ScannedRobotEvent e) {
		
		

			smartFire(e.getDistance());
			scan();
			back(500);
			turnRight(180);
		

	}//end scannedrobot
	

	
	public void smartFire(double robotDistance) {
		if (robotDistance > 100) {
			fire(2);
			fire(1);
			ahead(100);
			fire(2);
		}
		if (robotDistance < 100) {
			fire(3);
			fire(3);
			ahead(50);
			fire(3);
			back(10);
			scan();
			fire(3);
		}
		
	}//end thinking	
	public void opportunist(int numOthers) {
		
		if (numOthers > 3){
			stop();
			ahead(50);
			back(50);
			turnRight(90);
		}
		if (numOthers < 4){
			resume();
		}
}	

	 public void onHitByBullet(HitByBulletEvent event) {
		ahead(100);
	}
	
	public void onHitByWall(HitWallEvent e) {
		turnRight(45);
		back(50);
		turnRight(45);
		ahead(300);
		scan();
	}
}// end of Iceberg
