package ly;
import robocode.*;
import java.awt.Color;


public class Starswords extends AdvancedRobot
{
	boolean notHit = true;
	boolean noLock = false;
	public void run() 
	{	setColors(Color.green,Color.blue,Color.red);	
		setAdjustGunForRobotTurn(true);
					
		while(notHit)
		{
			turnRight(30);
			turnGunLeft(100);
			ahead(120);
			
			setTurnRight(18);
			if (!noLock)
			{
				setTurnGunRight(120);
			}
				else
				{
					stop();
				}
				
			ahead(120);
			setTurnRight(30);
			if (!noLock)
			{
				setTurnGunRight(200);
			}
				else
				{
					stop();	
				}
				ahead(200);
		}	
		
	}
	
	public void onScannedRobot(ScannedRobotEvent e)
	{
		/*if(isTeammate(e.getName()))
		{
			return;
		}
	*/
	smartFire(e.getDistance());
	turnGunRight(50);
	
	notHit=false;
	noLock = false;
	
	double absoluteBearing = getHeading() + e.getBearing();
	double bearingFromGun = normalRelativeAngle(absoluteBearing - getGunHeading());
	turnGunRight(bearingFromGun);
	
	if (e.getDistance() < 700)
	{
		if (getEnergy() < 20) 
		{
			fire(1);
		}
			else
			{
				fire(3);
			}
	notHit=true;
	}
		else
		{
			double where = getHeading() - getRadarHeading();
			if (where >0)
			{
			turnLeft(where); 
			}
				else
				{
					turnRight(-where); 
				}
				
		noLock = false;
		notHit = true;
		}
	
	}
	
	public void onBulletHit(BulletHitEvent f){
		noLock = false;
			
	}
	
	public void onHitByBullet(HitByBulletEvent e) {
		turnRight(90- e.getBearing());
		ahead(100);
		noLock = false;
	}
	public void onHitWall(HitWallEvent e){
		turnRight(20);
		ahead(100);
		
	}
	
	public double normalRelativeAngle(double angle) {
		if (angle > -180 && angle <= 180)
			return angle;
		double fixedAngle = angle;
		while (fixedAngle <= -180)
			fixedAngle += 360;
		while (fixedAngle > 180)
			fixedAngle -= 360;
		return fixedAngle;
	}	
	
	public void smartFire(double robotDistance) 
	{
		if (robotDistance > 300 || getEnergy() < 15)
			fire(1);
		else if (robotDistance > 200)
			fire(2);
		else
			fire(3);
	}
	
		public void onHitRobot(HitRobotEvent e)
	{
		
		/*if(isTeammate(e.getName()))
		{
			return;
		}
*/
		turnRight(e.getBearing());
		turnGunRight(getHeading()-getGunHeading());
		fire(3);
		ahead(100);
						
	}		
		public void onWin(WinEvent e)
		{
			for (int i = 0; i < 150; i++)
			{
				turnGunRight(360);
				turnLeft(360);
			}
	}
	
}
