package rc;
import robocode.*;
//import java.awt.Color;

/**
 * Ricky_C - a robot by (Ali Carim)
 */
public class Ricky_C extends Robot {
	
	static int counter = 0;

	public void run() {
		// After trying out your robot, try uncommenting the import at the top,
		// and the next line:
		//setColors(Color.red,Color.blue,Color.green);
		while(true) {
			// Replace the next 4 lines with any behavior you would like
			if (getOthers() > 1) {
				ahead(100);
				turnRight(100);
				ahead(100);
				turnLeft(100);
				turnGunRight(360);
				back(200);
				if (counter > 3){
				turnLeft(200);
				turnGunLeft(100);
				ahead(200);
				}
			}
			else if (getOthers() == 1 && getEnergy() > 1) {
				ahead(200);
				turnGunRight(360);
				back(200);
				turnGunRight(360);
			}
		}
	}

	/**
	 * onScannedRobot: What to do when you see another robot
	 */
	public void onScannedRobot(ScannedRobotEvent e) {
		// Calculate exact location of the robot
		double absoluteBearing = getHeading() + e.getBearing();
		double bearingFromGun = normalRelativeAngle(absoluteBearing - getGunHeading());
		// If it's close enough, fire!
		if (Math.abs(bearingFromGun) <= 3) {
			turnGunRight(bearingFromGun);
			// We check gun heat here, because calling fire() 
			// uses a turn, which could cause us to lose track
			// of the other robot.
			if (getGunHeat() == 0)
				fire (Math.min(3 - Math.abs(bearingFromGun),getEnergy() - .1));
		}
		// otherwise just set the gun to turn.
		// Note:  This will have no effect until we call scan()
		else {
			turnGunRight(bearingFromGun);
		}
		// Generates another scan event if we see a robot.
		// We only need to call this if the gun (and therefore radar)
		// are not turning.  Otherwise, scan is called automatically.
		if (bearingFromGun == 0)
			scan();
			
		if (Math.abs(bearingFromGun) < 1) {
			fire(100);	
			
		}

		
	}

	/**
	 * onHitByBullet: What to do when you're hit by a bullet
	 */
	public void onHitByBullet(HitByBulletEvent e) {
		turnLeft(90 - e.getBearing());
	}
	
	public void onHitRobot(HitRobotEvent e) {
			fire(200);
	}
	
	public double normalRelativeAngle(double angle) {
		if (angle > -180 && angle <= 180)
			return angle;
		double fixedAngle = angle;
		while (fixedAngle <= -180)
			fixedAngle += 360;
		while (fixedAngle > 180)
			fixedAngle -= 360;
		return fixedAngle;
	}
	
	public void onBulletHit(BulletHitEvent e) {
		counter = 0;	
	}
	
	public void onBulletMissed(BulletMissedEvent e) {
		counter = counter + 1;
	}
	

	
	
}
	
	
	
