package ac;
import robocode.*;
import java.awt.Color;

public class Ultima extends AdvancedRobot
{	
	
	boolean movingForward;
	
	public void run() {
		
		setColors(Color.BLACK, Color.BLUE, Color.WHITE);
		
		while(true) {
			ahead(200);
			turnRight(45);
			back(200);
			turnGunRight(180);
			back(200);
			turnLeft(45);
			ahead(200);
			turnGunRight(180);
			back(500);
			turnRight(90);
			ahead(500);
			turnLeft(90);
			turnGunRight(360);
		}
		
	}

	public void onScannedRobot(ScannedRobotEvent e) {
		fire(3);
	}
	
	public void onHitByBullet(HitByBulletEvent e) {
		turnLeft(90 - e.getBearing());
	}
	
	public void onHitWall(HitWallEvent e)
	{
		reverseDirection();
	}
	
	public void reverseDirection() {
		if (movingForward)
		{
			setBack(100);
			movingForward = false;
		}
		else
		{
			setAhead(100);
			movingForward = true;
		}
	}
	
	public void onHitRobot(HitRobotEvent e)
	{
		if (e.isMyFault())
			reverseDirection();
	}	
	
	public void onWin(WinEvent e) {
		for(int i=0; i<100; i++) {
			turnRight(360);
			turnGunLeft(360);
			turnRadarRight(360);
		}
	
	}
	
}