package jmm;
import robocode.*;
import java.awt.Color;

/**
 * Yuske - a robot by (Jeremy M. March)
 */
public class Yuske extends Robot
{
	
	boolean peek;		
	double moveAmount;	
	
	public void run() {
		setColors(Color.red,Color.black,Color.red);
		
		moveAmount = Math.max(getBattleFieldWidth(),getBattleFieldHeight());
		
		peek = false;
		
		turnLeft(getHeading() % 90);
		ahead(moveAmount);
		
		peek = true;
		turnGunRight(90);
		turnRight(90);
		
		while (true)
		{
			
			peek = true;
			
			ahead(moveAmount);
			
			peek = false;
			
			turnRight(90);
		}
	}
	
	
	public void onHitRobot(HitRobotEvent e) {
		
		if (e.getBearing() > -90 && e.getBearing() < 90)
			back(100);
		
		else
			ahead(100);
	}

	
	public void onScannedRobot(ScannedRobotEvent e) {
		fire(2);
		
		if (peek)
			scan();
	
	if (e.getEnergy() > 16)
			fire(3);
		else if (e.getEnergy() > 10)
			fire(2);
		else if (e.getEnergy() > 4)
			fire(1);
		else if (e.getEnergy() > 2)
			fire(.5);
		else if (e.getEnergy() > .4)
			fire(.1); 
	
	}
}															